//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AC25978022C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AC25978022C.cm

//## begin module%4AC25978022C.cp preserve=no
//## end module%4AC25978022C.cp

//## Module: PlotGroupCreator%4AC25978022C; Package body
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotGroupCreator.cxx

//## begin module%4AC25978022C.additionalIncludes preserve=no
//## end module%4AC25978022C.additionalIncludes

//## begin module%4AC25978022C.includes preserve=yes
#include <XSUtil/Numerics/Numerics.h>
//## end module%4AC25978022C.includes

// PlotGroup
#include <XSPlot/Plot/PlotGroup.h>
// PlotSettings
#include <XSPlot/Plot/PlotSettings.h>
// PlotGroupCreator
#include <XSPlot/Plot/PlotGroupCreator.h>


//## begin module%4AC25978022C.declarations preserve=no
//## end module%4AC25978022C.declarations

//## begin module%4AC25978022C.additionalDeclarations preserve=yes
//## end module%4AC25978022C.additionalDeclarations


// Class PlotGroupCreator 

//## begin PlotGroupCreator::NODATA%4AC2658402EE.attr preserve=no  public: static Real {UC} -1.2e-34
const Real PlotGroupCreator::s_NODATA = -1.2e-34;
//## end PlotGroupCreator::NODATA%4AC2658402EE.attr

PlotGroupCreator::PlotGroupCreator()
  //## begin PlotGroupCreator::PlotGroupCreator%4AB7C14001A9_const.hasinit preserve=no
  //## end PlotGroupCreator::PlotGroupCreator%4AB7C14001A9_const.hasinit
  //## begin PlotGroupCreator::PlotGroupCreator%4AB7C14001A9_const.initialization preserve=yes
  //## end PlotGroupCreator::PlotGroupCreator%4AB7C14001A9_const.initialization
{
  //## begin PlotGroupCreator::PlotGroupCreator%4AB7C14001A9_const.body preserve=yes
  //## end PlotGroupCreator::PlotGroupCreator%4AB7C14001A9_const.body
}


PlotGroupCreator::~PlotGroupCreator()
{
  //## begin PlotGroupCreator::~PlotGroupCreator%4AB7C14001A9_dest.body preserve=yes
  //## end PlotGroupCreator::~PlotGroupCreator%4AB7C14001A9_dest.body
}



//## Other Operations (implementation)
void PlotGroupCreator::setXaxis (const PlotSettings& settings, PlotGroup* group, int firstChannel, int lastChannel, Real eMin, Real eMax, int point)
{
  //## begin PlotGroupCreator::setXaxis%4AC259F2015A.body preserve=yes
    
   Real unitFactor = 1.0; 
   switch (settings.xOption())
   {
      default:
      case CHANNELS:
         // lastChannel is 1 beyond the last channel contributing to the bin.
         // firstChannel and lastChannel are 0-based, display is 1-based.
         if ( group->single )
         {
            group->xAxis.errors[0][point] = 0.5*group->channelPlotSpacing;      
            group->xAxis.data[point] = group->xAxis.errors[0][point]  - 0.5;
         }
         else
         {
            group->xAxis.data[point] =  0.5*(lastChannel - 1 + firstChannel) + 1; 
            group->xAxis.errors[0][point] =  0.5*(lastChannel - firstChannel);                       
         }
         break;
      case ENERGY:
         unitFactor = settings.getUnitFactor(ENERGY);
         group->xAxis.data[point] = 0.5*(eMax + eMin)*unitFactor;
         group->xAxis.errors[0][point] = 0.5*(eMax - eMin)*unitFactor;
         break;
      case WAVELENGTH:
         unitFactor = settings.getUnitFactor(WAVELENGTH);
         if ( eMax <= 0 || eMin <= 0)
         {
            group->xAxis.data[point] = s_NODATA;
            group->xAxis.errors[0][point] = s_NODATA;       
         }
         else
         {
            group->xAxis.data[point]      = 0.5*Numerics::KEVTOA*(1./eMax + 1./eMin)*unitFactor;
            group->xAxis.errors[0][point] =  0.5*Numerics::KEVTOA*(1./eMin - 1./eMax)*unitFactor;                                     
         }
         break;  
   }  
  //## end PlotGroupCreator::setXaxis%4AC259F2015A.body
}

void PlotGroupCreator::determineXRange (const std::vector<PlotGroup*>& plotGroups, Real* pXlow, Real* pXhigh)
{
  //## begin PlotGroupCreator::determineXRange%4B3D0F7A0010.body preserve=yes
   Real xlow = 1.e99;
   Real xhigh = -1.e99;
   
   for (size_t iGroup=0; iGroup<plotGroups.size(); ++iGroup)
   {
      const PlotGroup* gr = plotGroups[iGroup];
      const int npts = gr->n;
      const Real xAxis_0 = gr->xAxis.data[0];
      const Real xAxis_N = gr->xAxis.data[npts-1];
      Real err_0 = 0.0;
      Real err_N = 0.0;
      // Don't assume all PlotGroups have kept their X-axis errors vector.
      // Some commands may have decided to erase it if it's not needed.
      // However DO assume that if it's there, it will be the proper size.
      if (gr->xAxis.errors.size())
      {
         err_0 = gr->xAxis.errors[0][0];
         err_N = gr->xAxis.errors[0][npts-1];
      }
      if (xAxis_N > xAxis_0)
      {
         xlow = std::min(xAxis_0 - err_0,xlow);
         xhigh = std::max(xAxis_N + err_N,xhigh);
      }
      else
      {
         xlow = std::min(xAxis_N - err_N,xlow);                                
         xhigh = std::max(xAxis_0 + err_0,xhigh);
      }
   }
      
   *pXlow = xlow;
   *pXhigh = xhigh;
  //## end PlotGroupCreator::determineXRange%4B3D0F7A0010.body
}

// Additional Declarations
  //## begin PlotGroupCreator%4AB7C14001A9.declarations preserve=yes
  //## end PlotGroupCreator%4AB7C14001A9.declarations

//## begin module%4AC25978022C.epilog preserve=yes
//## end module%4AC25978022C.epilog
